﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;

namespace BackGroundWorker
{
    public partial class MainWindow : Window
    {
        DataTable MyDataTable;

        public DataView Records
        {
            get { return MyDataTable.DefaultView; }
        }

        char[] delimiter = { ',' };
        int i = 1;

        public MainWindow()
        {
            InitializeComponent();

            DataContext = this;
            //Create DataTable
            MyDataTable = new DataTable();
            MyDataTable.Columns.Add("First Name", typeof(String));
            MyDataTable.Columns.Add("Last Name", typeof(String));

            //Create new BackGroundWorker
            var bgw = new System.ComponentModel.BackgroundWorker();

            //Start execution of a background operation.
            bgw.RunWorkerAsync();

            /*Occurs when RunWorkerAsync is called.
             Perform time-concuming task here */
            bgw.DoWork += (s, e) =>
                {
                    for (int j = 0; j < 20; j++)
                    {
                        System.Threading.Thread.Sleep(1000);
                        var _fName = "FName" + (i).ToString();
                        var _lName = "LName" + (i++).ToString();
                        var _datum = _fName + "," + _lName;
                        AddNewRow(_datum);
                    }
                };

            //Background operation completed
            bgw.RunWorkerCompleted += (s, e) =>
            {
                // Back on UI thread
                Console.WriteLine("Data Updated");
            };
        }


        void AddNewRow(string _data)
        {
            Application.Current.Dispatcher.Invoke
                (System.Windows.Threading.DispatcherPriority.Background,
                new Action(() =>
            {
                // Add row on UI thread
                MyDataTable.Rows.Add(_data.Split(delimiter));
                //Select cell in last row and first column on UI thread
                var _row = c1DataGrid1.Rows.Count - 1;
                var _dataRow = this.c1DataGrid1.Rows[_row];
                var _col = c1DataGrid1.Columns.Count - 1;
                c1DataGrid1.Selection.Clear();
                c1DataGrid1.Selection.Add(_dataRow, _dataRow);
                //Scroll the grid to the selected cell                
                c1DataGrid1.ScrollIntoView(_row, _col);
            }));
        }
    }
}
